void colourMapIni() // initial defualt colour map
{
  // Red
  colourRL[1] = 128;
  colourGL[1] = 0;
  colourBL[1] = 0;
  colourRH[1] = 255;
  colourGH[1] = 64;
  colourBH[1] = 64;
  // Green
  colourRL[2] = 0;
  colourGL[2] = 128;
  colourBL[2] = 0;
  colourRH[2] = 32;
  colourGH[2] = 255;
  colourBH[2] = 32;
  // Blue
  colourRL[3] = 0;
  colourGL[3] = 0;
  colourBL[3] = 128;
  colourRH[3] = 32;
  colourGH[3] = 32;
  colourBH[3] = 255;
  // Yellow
  colourRL[4] = 128;
  colourGL[4] = 128;
  colourBL[4] = 0;
  colourRH[4] = 255;
  colourGH[4] = 255;
  colourBH[4] = 32;
  // Purple
  colourRL[5] = 128;
  colourGL[5] = 0;
  colourBL[5] = 128;
  colourRH[5] = 255;
  colourGH[5] = 32;
  colourBH[5] = 255;
  // White
  colourRL[6] = 192;
  colourGL[6] = 192;
  colourBL[6] = 192;
  colourRH[6] = 255;
  colourGH[6] = 255;
  colourBH[6] = 255;
  // Black
  colourRL[7] = 0;
  colourGL[7] = 0;
  colourBL[7] = 0;
  colourRH[7] = 32;
  colourGH[7] = 32;
  colourBH[7] = 32;
  // Custom
  colourRL[8] = 0;
  colourGL[8] = 0;
  colourBL[8] = 0;
  colourRH[8] = 0;
  colourGH[8] = 0;
  colourBH[8] = 0;
}

void getLatest()
{
  timeout = 0;
  while((port.available() == 0) && (timeout < 1000))
  {
    delay(1);
    timeout++;
  }

  if(timeout > 998)
  {
    println("TIMEOUT CAM LOST");
    camAvail = false;
  } 

  else {
    latest = port.read();    
    camAvail = true;
  }

  if(camAvail == false)
  {
    port.write("DF\r");

    getACK();
  }

  if(latest == -1)
  {
    latest = 0;
  }  
}

void getACK()
{
  valid = true;
  timeout = 0;
  while((port.available() < 4) && (timeout < 400))
  {
    delay(1);
    timeout++;
  }

  if(timeout > 398)
  {
    valid = false;
    println("TIMEOUT CAM LOST");
    camAvail = false;
  }

  latest = port.read();
  if(latest != 65)
  {
    valid = false;
    print("ACK Error 1st: ");
    println(latest);
  }
  latest = port.read();
  if(latest != 67)
  {
    valid = false;
    print("ACK Error 2nd: ");
    println(latest);
  }
  latest = port.read();
  if(latest != 75)
  {
    valid = false;
    print("ACK Error 3rd: ");
    println(latest);
  }
  latest = port.read();
  if(latest != 13)
  {
    valid = false;
    print("ACK Error 4th: ");
    println(latest);
  }

  print("ACK? ");
  println(valid);

  if(valid == false)
  {
    if(port.available() != 0)
    {
      //delay(5000);
    }
  }
  port.clear();
}

void getFrame()
{
  for(int i = 1; i != 73; i++)
  {
    getLatest(); // single packet must be 0x0B

    if(debugDump)
    {
      print("Start Indicator (11): ");
      println(latest);
    }

    if(latest != 11)
    {
      print("Sync Error (11): ");
      println(latest);
    }

    colnum = 1;

    getLatest(); // line number

    if(debugDump)
    {
      print("Line Indicator: ");
      println(latest);
    }

    linenum = latest;
    getLatest();    
    while(latest != 15)
    {
      temp = colnum + 176 * linenum;
      if(temp < 0)
      {
        temp = 0;
      }
      if(temp > 177 * 75)
      {
        temp = 177 * 75;
      }

      pix[temp] = latest;

      if(debugDump)
      {
        print("Pixel Data: ");
        print(colnum);
        print(" ");
        print(linenum);
        print(" ");
        println(latest);
      }

      colnum++;
      getLatest();
    }

    if(debugDump)
    {
      print("End of Line (15): ");
      println(latest);
    }

    if(latest != 15)
    {
      print("Sync Error (15): ");
      println(latest);
    }
  }
}

void drawFrame()
{
  println("Processing");
  for(int a = 0; a != 71; a++)
  {
    for(int b = 1; b != 176; b++)
    {
      pixH[b + 176 * a] = pix[b + 176 * a] / 16;
      pixL[b + 176 * a] = pix[b + 176 * a];
      pixL[b + 176 * a] -= pixH[b + 176 * a] * 16;
      pixH[b + 176 * a] *= 16;
      pixL[b + 176 * a] *= 16;        
    }
  }
  redfirst = false;
  println("Drawing");
  for(int a = 1; a != 72; a++)
  {
    for(int b = 1; b != 177; b++)
    {
      colorMode(RGB);
      temp = b + (176 * a) - 176;

      if(redfirst)
      {
        redfirst = false;          
        pixR[temp] = pixH[temp];
        pixG[temp] = pixL[temp];
        pixB[temp] = pixL[temp + 1];          
      } 
      else {
        redfirst = true;
        pixR[temp] = pixH[temp + 1];
        pixG[temp] = pixL[temp + 1];
        pixB[temp] = pixL[temp];                  
      }
      fill(pixR[temp], pixG[temp], pixB[temp], 255);
      stroke(pixR[temp], pixG[temp], pixB[temp], 255);
      if(debugDraw)
      {
        print(b);
        print(" ");
        print(a);
        print(" Green: ");
        print(pixG[temp]);
        print(" Blue: ");
        print(pixB[temp]);
        print(" Red: ");
        println(pixR[temp]);
      }
      point(b, a * 2);
      point(b, a * 2 + 1);

      fill(pixR[temp], pixG[temp], pixB[temp], 96);
      stroke(pixR[temp], pixG[temp], pixB[temp], 96);      
      point(b + 200, a * 2);
      point(b + 200, a * 2 + 1);
    }
  }
}

void frameDump()
{
  println("Start Frame Dump");
  port.write("DF\r");

  getACK();

  if(valid == true)
  {
    getFrame();
    drawFrame();
  }

  port.clear(); // empty buffer
}

void CMap()
{
  println("Starting Colour Map Upload");

  port.write("SM");
  for(int c = 1; c != 8; c++)
  {
    port.write(byte(colourRL[c]));
    if(debugCMap)
    {
      print("colourRL");
      print(c);
      print(": ");
      print(colourRL[c]);
      print(" ");
    }
    port.write(byte(colourRH[c]));
    if(debugCMap)
    {
      print("colourRH");
      print(c);
      print(": ");
      print(colourRL[c]);
      print(" ");
    }
  }
  for(int c = 1; c != 8; c++)
  {    
    port.write(byte(colourGL[c]));
    if(debugCMap)
    {
      print("colourGL");
      print(c);
      print(": ");
      print(colourGL[c]);
      print(" ");
    }
    port.write(byte(colourGH[c]));
    if(debugCMap)
    {
      print("colourGH");
      print(c);
      print(": ");
      print(colourGH[c]);
      print(" ");
    }
  }
  for(int c = 1; c != 8; c++)
  {
    port.write(byte(colourBL[c]));
    if(debugCMap)
    {
      print("colourBL");
      print(c);
      print(": ");
      print(colourBL[c]);
      print(" ");
    }
    port.write(byte(colourBH[c]));
    if(debugCMap)
    {
      print("colourBH");
      print(c);
      print(": ");
      print(colourBH[c]);
      print(" ");
    }
  }
  port.write("\r");

  getACK();
}

void getTrack()
{
  getLatest(); // should be 10

  if(debugTrack)
  {
    print("Start of Packet (10): ");
    println(latest);
  }

  if(latest != 10)
  {
    print("Sync Error (10): ");
    println(latest);
  }

  getLatest(); // number of objects

  if(debugTrack)
  {
    print("Number of Objects: ");
    println(latest);
  }

  objNumA = latest;

  for(objNum = latest; objNum != 0; objNum--)
  {
    getLatest();
    objColour[9 - objNum] = latest;
    getLatest();
    objXMin[9 - objNum] = latest;
    getLatest();
    objXMax[9 - objNum] = latest;
    getLatest();
    objYMin[9 - objNum] = latest;
    getLatest();
    objYMax[9 - objNum] = latest;

    if(debugTrack)
    {
      print("objNum: ");
      print(objNumA + 1 - objNum);
      print(" objColour: ");
      print(objColour[9 - objNum]);
      print(" objXMin: ");
      print(objXMin[9 - objNum]);
      print(" objXMax: ");
      print(objXMax[9 - objNum]);
      print(" objYMin: ");
      print(objYMin[9 - objNum]);
      print(" objYMax: ");
      println(objYMax[9 - objNum]);
    }        
  }

  getLatest(); // must be 255

  if(debugTrack)
  {
    print("Tracking Complete (255): ");
    println(latest);
  } 

  if(latest != 255)
  {
    print("Sync Error (255): ");
    println(latest);
  }

  println("Tracking Complete");
  println("Note, ACK error unavoidable");

  port.clear();
  port.write("DT\r");
  port.clear();
  getACK();
  while(valid != true)
  {
    port.write("DT\r");
    getACK();      
  }
}

void drawTrack()
{
  // Draw Trackign Boxes
  println("Drawing");
  noFill();
  rectMode(CORNER);

  for(objNum = objNumA; objNum != 0; objNum--)
  {
    stroke(colourRH[9 - objNum], colourGH[9 - objNum], colourBH[9 - objNum], 255);      
    rect(objXMin[9 - objNum] + 200, objYMin[9 - objNum], objXMax[9 - objNum] + 200, objYMax[9 - objNum]);
  }
}

void track()
{
  println("Initiate Tracking");
  port.clear();
  port.write("ET\r");
  getACK();

  if(valid)
  {
    getTrack();
    drawTrack();    
  }
}

void setup()
{
  size(700, 200);
  println("Available serial ports:");
  println(Serial.list());
  port = new Serial(this, Serial.list()[0], 115200);
  colourMapIni();
}
